--- sh-utils-2.0.12/src/printf.c.bero	Thu Aug 29 22:46:43 2002
+++ sh-utils-2.0.12/src/printf.c	Thu Aug 29 22:46:02 2002
@@ -86,6 +86,9 @@
 /* The name this program was run with. */
 char *program_name;
 
+/* Hack to support %ll */
+static int ll;
+
 void
 usage (int status)
 {
@@ -188,6 +191,8 @@
   return val;								 \
 }									 \
 
+STRTOX (unsigned long long, xstrtoull, (strtoull (s, &end, 0)))
+STRTOX (long long, xstrtoll, (strtoll (s, &end, 0)))
 STRTOX (unsigned long int, xstrtoul, (strtoul (s, &end, 0)))
 STRTOX (long int,          xstrtol,  (strtol  (s, &end, 0)))
 STRTOX (double,            xstrtod,  (strtod  (s, &end)))
@@ -325,6 +330,22 @@
     {
     case 'd':
     case 'i':
+     if ( ll ) {
+      if (field_width < 0)
+	{
+	  if (precision < 0)
+	    printf (p, xstrtoll (argument));
+	  else
+	    printf (p, precision, xstrtoll (argument));
+	}
+      else
+	{
+	  if (precision < 0)
+	    printf (p, field_width, xstrtoll (argument));
+	  else
+	    printf (p, field_width, precision, xstrtoll (argument));
+	}
+     } else {
       if (field_width < 0)
 	{
 	  if (precision < 0)
@@ -339,12 +360,30 @@
 	  else
 	    printf (p, field_width, precision, xstrtol (argument));
 	}
-      break;
+
+     }
+     break;
 
     case 'o':
     case 'u':
     case 'x':
     case 'X':
+     if (ll) {
+      if (field_width < 0)
+	{
+	  if (precision < 0)
+	    printf (p, xstrtoull (argument));
+	  else
+	    printf (p, precision, xstrtoull (argument));
+	}
+      else
+	{
+	  if (precision < 0)
+	    printf (p, field_width, xstrtoul (argument));
+	  else
+	    printf (p, field_width, precision, xstrtoul (argument));
+	}
+     } else {
       if (field_width < 0)
 	{
 	  if (precision < 0)
@@ -359,7 +398,8 @@
 	  else
 	    printf (p, field_width, precision, xstrtoul (argument));
 	}
-      break;
+     }
+     break;
 
     case 'f':
     case 'e':
@@ -429,6 +469,7 @@
 	  direc_start = f++;
 	  direc_length = 1;
 	  field_width = precision = -1;
+	  ll = 0;
 	  if (*f == '%')
 	    {
 	      putchar ('%');
@@ -494,8 +535,14 @@
 	    }
 	  if (*f == 'l' || *f == 'L' || *f == 'h')
 	    {
+              char prev=*f;
 	      ++f;
 	      ++direc_length;
+	      if(prev=='l' && *f=='l') {
+                ll++;
+		f++;
+		direc_length++;
+	      }
 	    }
 	  if (!strchr ("diouxXfeEgGcs", *f))
 	    error (1, 0, _("%%%c: invalid directive"), *f);
